const gulp = require('gulp');
const zip = require('gulp-zip');

const zipArtifact = () => gulp.src([
  '**/*',
  '!terraform/**',
  '!*.md',
  '!*.zip',
  '!*.pdf',
  '!tsconfig.json',
  '!*-lock.json',
  '!*.lock',
  '!*.log',
  '!*.yml',
  '!gulpfile.js',
  '!jest.*.js',
  '!tmp/**',
  '!build/**',
  '!coverage/**',
  '!dist/src/local.*',
  '!dist/src/**.ts',
  '!dist/src/**.map',
  '!dist/tests/**',
  '!tests/**',
  '!src/**',
  '!node_modules/@types/**',
  '!node_modules/@jest/**',
  '!node_modules/jest/**',
  '!node_modules/jest-*/**',
  '!node_modules/typescript/**',
  '!node_modules/ttypescript/**',
  '!node_modules/tsutils/**',
  '!node_modules/gulp/**',
  '!node_modules/gulp-zip/**',
  '!node_modules/@typescript-eslint/**',
  '!node_modules/@babel/**',
  '!node_modules/faker/**',
  '!node_modules/eslint/**',
  '!node_modules/@eslint/**',
  '!node_modules/eslint-*/**',
  '!node_modules/tsconfig/**',
  '!node_modules/tsconfig-*/**',
  '!node_modules/ts-node/**',
  '!node_modules/ts-node-*/**',
  '!node_modules/**/*.d.ts',
]).pipe(zip('lambda-code.zip', { compress: true }))
  .pipe(gulp.dest('.'));

module.exports.default = gulp.series(zipArtifact);
